package org.apithefire.servlet.wicket;

import javax.servlet.Servlet;

import org.apache.wicket.protocol.http.IWebApplicationFactory;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.protocol.http.WicketFilter;
import org.apache.wicket.protocol.http.WicketServlet;
import org.apithefire.servlet.dynamic.AbstractDynamicServlet;

public abstract class DynamicWicketServlet extends AbstractDynamicServlet {
	
	// TODO: should rename to newWebApplication() since it is called by factory
	public abstract WebApplication getWebApplication();

	@Override
	protected Servlet newServletImpl() {
		return new WicketServlet() {
			@Override
			protected WicketFilter newWicketFilter() {
				return new WicketFilter() {
					@Override
					protected IWebApplicationFactory getApplicationFactory() {
						return new IWebApplicationFactory() {
							public WebApplication createApplication(WicketFilter filter) {
								return getWebApplication();
							}
						};
					}
				};
			}
		};
	}

}
